﻿@using System.Xml
@using Newtonsoft.Json
@using Sitecore.Exceptions
@using Sitecore.ExperienceAnalytics.Client
@using Sitecore.Mvc
@using Sitecore.Web.UI.Controls.Common.Renderings
@using Sitecore.Web.UI.Controls.Common.Texts
@using Sitecore.Web.UI.Controls.Common.UserControls
@using Sitecore
@using Sitecore.Configuration
@using Vhs.XAnalyticsReportViewerRestriction.Services
@using Globals = Sitecore.ExperienceAnalytics.Client.Globals
@using UserControl = Sitecore.Web.UI.Controls.Common.UserControls.UserControl
@model Sitecore.Mvc.Presentation.RenderingModel
@{
    var rendering = Html.Sitecore().Controls().GetUserControl(Model.Rendering);

    rendering.Class = "sc-SubsiteFilter";
    rendering.Requires.Script("client", "SubsiteFilter.js");
    rendering.Attributes.Add("data-bind", "visible: isVisible");
    rendering.HasNestedComponents = true;

    var errorMessages = new
    {
        InvalidSubsite = Helper.GetTextValue(Globals.System.Texts.ErrorMessages.InvalidSubsite),
        ConfigurationError = Helper.GetTextValue(Globals.System.Texts.ErrorMessages.ConfigurationError)
    };

    rendering.Attributes.Add("data-sc-errortexts", JsonConvert.SerializeObject(errorMessages));
}
@EmbedSubsiteFilter(rendering)
@helper EmbedSubsiteFilter(UserControl rendering)
{
var renderingId = rendering.ControlId;
var helper = new RenderingHelper(Html, renderingId);
var sites = helper.GetSiteComboBoxItems();
if (ConfigurationService.Enabled)
{
    sites = GetSiteListByRoles(sites);
}

helper.MakeBorder("ContentWrapper", renderingId + "DropDownWrapper", contentWrapper =>
{
    helper.MakeRow("TextBorder", contentWrapper, true, textBorder => helper.MakeText("Text", textBorder, Globals.System.Texts.DefineCustomFilter, TextType.Title));

    helper.MakeRow("ControlsRow", contentWrapper, true, controlsRow =>
    {
        helper.MakeComboBox("SubsiteComboBox", controlsRow, sites);
        helper.MakeButton("SubmitButton", controlsRow, Globals.System.Texts.Apply.Guid.ToString(), "Primary");
        helper.MakeButton("ResetButton", controlsRow, Globals.System.Texts.RevertFiltersToStandard.Guid.ToString());
    });
});

// Rendering
    <div @rendering.HtmlAttributes>
        @Html.Sitecore().Controls().Rendering(Html, Globals.Bcl.Renderings.Containers.Border, renderingId + "DropDownWrapper", "", new { UsePadding = true })
    </div>
}
@functions{
    private static List<ComboBoxItem> GetSiteListByRoles(List<ComboBoxItem> sites)
    {
        const char Separator = ',';

        var user = Sitecore.Context.User;
        if (sites == null || !sites.Any() || user.IsAdministrator)
        {
            return sites;
        }

        var userRoles = Sitecore.Context.User.Roles;
        var superReportViewerRoles = ConfigurationService.SuperReportViewerRoles?.Split(Separator).ToList();
        if (superReportViewerRoles != null && userRoles.Any(x => superReportViewerRoles.Any(y => y.Equals(x.Name, StringComparison.OrdinalIgnoreCase))))
        {
            return sites;
        }

        var allowedSites = new List<ComboBoxItem>();

        var sitesAndReportViewerRoleList = ConfigurationService.SitesAndReportViewerRoleList;
        if (string.IsNullOrWhiteSpace(sitesAndReportViewerRoleList)) return allowedSites;
        var sitesXmlDoc = new XmlDocument();
        sitesXmlDoc.LoadXml(sitesAndReportViewerRoleList);


        foreach (var site in sites)
        {
            var siteXPath = string.Format("sites/{0}", site.ItemId);
            var allowedReportViewerRoles = sitesXmlDoc.SelectSingleNode(siteXPath)?.InnerText.Split(Separator).ToList();
            if (allowedReportViewerRoles == null || !allowedReportViewerRoles.Any()) continue;
            foreach (var userRole in userRoles)
            {
                var isAllowed = allowedReportViewerRoles.FirstOrDefault(x => x.Equals(userRole.Name, StringComparison.OrdinalIgnoreCase)) != null;
                if (isAllowed)
                {
                    allowedSites.Add(site);
                    break;
                }
            }
        }

        return allowedSites;
    }
}
